// JdvrSock.cpp: implementation of the CJdvrSock class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "JVSDKPDEMO.h"
#include "JdvrSock.h"
#include "JVSDKPDEMODlg.h"
#include "pconfig.h"
#include "JVSDKP.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

extern PCONFIG g_pconfig;
UINT JdvrSockProc(LPVOID pParam)
{
	CJdvrSock *p = (CJdvrSock *)pParam;
	p->Run();

	return 0;
}
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CJdvrSock::CJdvrSock()
{
	m_nChannel = -1;
	m_bRun	=	FALSE;
	m_bInThread = FALSE;
	m_pOwnerWnd = NULL;
	m_socket = -1;

}

CJdvrSock::~CJdvrSock()
{
}

BOOL CJdvrSock::StartLink()
{
	if ( m_bRun )
		return TRUE;

	if (m_nChannel == -1)
		return FALSE;

	if (m_bInThread)	//һ߳δ˳
	{
		if (WaitForSingleObject(m_pWinThread->m_hThread, 1000) != WAIT_OBJECT_0)
			return FALSE;
	}

	((CJVSDKPDEMODlg *)m_hParent)->m_lstInfo.AddString("ʼ");
	m_pWinThread = AfxBeginThread(JdvrSockProc, this, THREAD_PRIORITY_NORMAL);

	return TRUE;
}

BOOL CJdvrSock::StopLink()
{
	if ( m_bRun )
	{
		m_bRun = FALSE;
		((CJVSDKPDEMODlg *)m_hParent)->m_lstInfo.AddString("Ͽ");
	}

	return TRUE;
}

void CJdvrSock::Run()
{
	SOCKET_DATA_LARGE		m_data_large;
	UCHAR		DataBuffer[100*1024];

	//socket
	if (FALSE == CreateSocket())
	{
		m_bInThread = FALSE;
		((CJVSDKPDEMODlg *)m_hParent)->m_lstInfo.AddString("ʼʧ");
		return;
	}

	m_data_large.nTypeLens = CC_CONNECT;
	sendto(m_socket, (const char *)&m_data_large, 4, 0, &m_sockAddr,sizeof(m_sockAddr));


	m_bInThread = TRUE;

	//ʼѭ
	m_bRun = TRUE;
	sockaddr	sockAddr;
	int nSockAddrLen = sizeof(sockAddr);
	int nWritePos = 0;
	int nCurPack = 0;
	BOOL	bValidFrame = FALSE;
	int nResult;

	while ( m_bRun )
	{
		nResult = recvfrom(m_socket, (char *)&m_data_large, sizeof(SOCKET_DATA_LARGE), 0, &sockAddr, &nSockAddrLen);
		if (nResult > 0)
		{
			switch ( m_data_large.nTypeLens & 0xFF )
			{
			case CC_DATA:
				{
					const int i_idr = m_data_large.nFrameIDR >> 16;
					const int i_frame = m_data_large.nFrameIDR & 0xFFFF;
					const int i_cur_pack = m_data_large.nPackets & 0xFF;
					const int i_total_pack = m_data_large.nPackets >> 8;
					const int i_data_size = m_data_large.nTypeLens >> 8;
					//жǷƵ֡
					if ( m_data_large.nFrameIDR == 0 && m_data_large.nPackets == 0x0101 )
					{
						while (FALSE == JVSP_WriteToStreamOneFrame(m_nChannel, m_data_large.acData, i_data_size))
						{
							if (m_bRun == FALSE)
								break;
							Sleep(1);
						}
						break;
					}
					if (i_idr == i_frame)	//ؼ֡ݰ
					{
						if (i_cur_pack == 1)	//һٹǰ
						{
							nCurPack = 1;
							bValidFrame = TRUE;
							nWritePos = i_data_size;
							if (i_total_pack == 1)	//ؼֻ֡һ
							{
								while (FALSE == JVSP_WriteToStreamOneFrame(m_nChannel, m_data_large.acData, nWritePos))
								{
									if (m_bRun == FALSE)
										break;
									Sleep(1);
								}
							}
							else
							{
								memcpy(DataBuffer, m_data_large.acData, nWritePos);
							}
						}
						else	//İ
						{
							if (bValidFrame)
							{
								nCurPack++;
								//ȷ֤
								if (i_cur_pack != nCurPack)
								{
									bValidFrame = FALSE;
								}
								else
								{
									memcpy(DataBuffer + nWritePos, m_data_large.acData, i_data_size);
									nWritePos += i_data_size;
									if (i_total_pack == i_cur_pack)	//һ
									{
										while (FALSE == JVSP_WriteToStreamOneFrame(m_nChannel, DataBuffer, nWritePos))
										{
											if (m_bRun == FALSE)
												break;
											Sleep(1);
										}
									}
								}
							}
						}
					}
					else	//ǹؼ֡
					{
						if (bValidFrame)
						{
							if (i_cur_pack == 1)	//һٹǰ
							{
								nCurPack = 1;
								nWritePos = i_data_size;
								if (i_total_pack == 1)	//ؼֻ֡һ
								{
									while (FALSE == JVSP_WriteToStreamOneFrame(m_nChannel, m_data_large.acData, nWritePos))
									{
										if (m_bRun == FALSE)
											break;
										Sleep(1);
									}
								}
								else
								{
									memcpy(DataBuffer, m_data_large.acData, nWritePos);
								}
							}
							else	//İ
							{
								nCurPack++;
								//ȷ֤
								if (i_cur_pack != nCurPack)
								{
									bValidFrame = FALSE;
								}
								else
								{
									memcpy(DataBuffer + nWritePos, m_data_large.acData, i_data_size);
									nWritePos += i_data_size;
									if (i_total_pack == i_cur_pack)	//һ
									{
										while (FALSE == JVSP_WriteToStreamOneFrame(m_nChannel, DataBuffer, nWritePos))
										{
											if (m_bRun == FALSE)
												break;
											Sleep(1);
										}
									}
								}
							}
						}
					}
					break;
				}
			case CC_HEAD:
				{
					//CC_HEADnFrameIDR֡nPackets֡
					JVSP_OpenStream(m_nChannel, m_data_large.acData, sizeof(JVS_FILE_HEADER));
					RECT rt;
					((CJVSDKPDEMODlg *)m_hParent)->GetWindowRect(&rt);
					rt.left += 13;
					rt.right = rt.left + 352;
					rt.top += 32;
					rt.bottom = rt.top + 288;
					JVSP_SetVideoPreview(g_pconfig.PLAYER[0].nPlayer, ((CJVSDKPDEMODlg *)m_hParent)->GetSafeHwnd(), &rt, TRUE);
					((CJVSDKPDEMODlg *)m_hParent)->m_lstInfo.AddString("ӷɹ");
					break;
				}
			case CC_FRAME_SIZE:
				{
					//CC_FRAME_SIZEnFrameIDR֡nPackets֡
					CString s;
					s.Format("˴µķֱģʽ");
					((CJVSDKPDEMODlg *)m_hParent)->m_lstInfo.AddString(s);
					JVSP_OpenStream(m_nChannel, m_data_large.acData, sizeof(JVS_FILE_HEADER));
					RECT rt;
					((CJVSDKPDEMODlg *)m_hParent)->GetWindowRect(&rt);
					rt.left += 13;
					rt.right = rt.left + 352;
					rt.top += 32;
					rt.bottom = rt.top + 288;
					JVSP_SetVideoPreview(g_pconfig.PLAYER[0].nPlayer, ((CJVSDKPDEMODlg *)m_hParent)->GetSafeHwnd(), &rt, TRUE);
				}
				break;
			case CC_CLOSE:
				{
					((CJVSDKPDEMODlg *)m_hParent)->m_lstInfo.AddString("Ͽ");
					m_bRun = FALSE;
					break;
				}
			case CC_TEXT:
				{
					((CJVSDKPDEMODlg *)m_hParent)->m_lstInfo.AddString((PCHAR)m_data_large.acData);
					break;
				}
			default:
				break;
			}
		}
		else
		{
			Sleep(10);
		}
	}

	//رsocket
	m_data_large.nTypeLens = CC_CLOSE;
	sendto(m_socket, (const char*)&m_data_large, 4, 0, &m_sockAddr,sizeof(m_sockAddr));
	closesocket(m_socket);

	JVSP_CloseStream(m_nChannel);

	m_bInThread = FALSE;

}

BOOL CJdvrSock::CreateSocket()
{
	m_socket = socket(AF_INET, SOCK_DGRAM, 0);
	if (m_socket < 0)
	{
        return FALSE;
	}

	sockaddr_in sin;
	sin.sin_addr.S_un.S_addr = INADDR_ANY;
	sin.sin_family = AF_INET;
	sin.sin_port = 0;
	
	if (bind(m_socket, (struct sockaddr*)&sin, sizeof(sin)) < 0)
	{
		closesocket(m_socket);
		m_socket = -1;
		return FALSE;
	}

	sin.sin_addr.S_un.S_addr = inet_addr(g_pconfig.PLAYER[m_nChannel].szIP);
	sin.sin_family = AF_INET;
	sin.sin_port = htons(g_pconfig.PLAYER[m_nChannel].nPort);
	memcpy(&m_sockAddr, &sin, sizeof(sockaddr_in));

	int nSize = 128 * 1024;
	setsockopt(m_socket, SOL_SOCKET, SO_RCVBUF, (char *)&nSize, sizeof(int));

	unsigned long  non_block = 1;
	ioctlsocket(m_socket, FIONBIO, &non_block);

	return TRUE;
}
