#ifndef _JVS_PKG_H
#define _JVS_PKG_H

/************************************************************
Copyright (C), 2012-2013, Jovision Tech. co., Ltd.
File Name:		Jmp4pkg.h
Author:			
Version:		Ver 1.0
Date:			
				2012-11-20
				mp4װ⹦

				2012-12-7
				1.ڽзװmp4ļĹ
				2.뷵h264ǷΪؼ֡ƵĹ
Description:	
				װ:
				1. ʵֱ׼h264amrװmp4ʽļ
				   һֻװһ

				2.ֻJENC05.dll(h264)JAENC.dll(amr)
				  һ֡󷵻

				3 spsppsΪJENC05.dll OpenEncoder󷵻,
				  ȻOpenPackageʱֻʹһ
				4.װmp4ʱ,֡ϢΪʱļڽ
				  ڷװmp4

				װ:
				1. ʵְ׼h264amrmp4ļװ	
				   һֻһ
				2. صֻJDEC05.dll(h264 dec)
				   JADEC.dll(amr dec)
				3. ڷװmp4ļ,Ҫñͷļ
				   һAPI
				4. ʱļжȡ֡mp4ļеϢڽ
				    ڷװmp4ļ 
				


************************************************************/


#define JVS_API __declspec(dllexport)


// JP_PackageOneFrame ȽavPkt.type
#define JVS_PKG_VIDEO		1			// װƵ
#define JVS_PKG_AUDIO		2			// װƵ

// mp4 sps\pps
typedef struct _MP4_AVCC
{
	int					iSpsSize;			// h264 spsС
	int					iPpsSize;			// h264 ppsС
	unsigned char *		pSps;				// h264 sps
	unsigned char *		pPps;				// h264 pps
	
}MP4_AVCC;

// װʼʱƵ
typedef struct _PKG_VIDEO_PARAM				
{											
	
	int					iFrameWidth;		// ֡
	int					iFrameHeight;		// ֡߶
	float				fFrameRate;			// ֡ PAL = 25, NTSC = 30
	MP4_AVCC			avcC;				// mp4 sps\pps

}PKG_VIDEO_PARAM, * PPKG_VIDEO_PARAM;


// װ(ƵƵ)
typedef struct _AV_PACKET
{
	unsigned int		iType;				// װ֡(ƵƵ)
	unsigned char *		pData;				// װָ
	unsigned int		iSize;				// װݴС
}AV_PACKET, * PAV_PACKET;


typedef struct MP4_PKG *	MP4_PKG_HANDLE;	//װ, Open

/**********************************************************************************
Function:		JP_OpenPackage
Description:	򿪷װJP_ClosePackageɶʹ
Param:			вɵ߶ 	
				PPKG_VIDEO_PARAM pVideoParam	// װƵ wdith, sps..
				BOOL			 bWriteVideo	// ǷдƵ
				BOOL			 bWriteAudio	// ǷдƵ
				char *			 pszmp4file     // Ϊmp4ļ
				char *			 pszIdxFile		// ļ,֡
												// mp4ļеϢ,ڷװ
												// mp4ļ(չ)
												
Return:			طװ, NULL,ʾʧ,ʾɹ      	  
**********************************************************************************/ 
JVS_API	MP4_PKG_HANDLE	JP_OpenPackage		(PPKG_VIDEO_PARAM	pVideoParam, 
											 BOOL				bWriteVideo, 
											 BOOL				bWriteAudio, 
											 char *				pszmp4file,
											 char *				pszIdxFile);


/**********************************************************************************
Function:		JP_ClosePackage
Description:	رշװJP_OpenPackageɶʹ
Param:			MP4_PKG_HANDLE	h	// װ
Return:				  
**********************************************************************************/ 
JVS_API	void			JP_ClosePackage		(MP4_PKG_HANDLE h);


/**********************************************************************************
Function:		JP_PackageOneFrame
Description:	װһ֡h264amr
Param:			MP4_PKG_HANDLE	h	// װ
				PAV_PACKET pAVPkt	// h264amr֡ݽṹ
Return:			 TURE, ʾɹFALSE,ʾʧ	  
**********************************************************************************/ 
JVS_API	BOOL			JP_PackageOneFrame	(MP4_PKG_HANDLE h, PAV_PACKET pAVPkt);







// JP_UnpkgOneFrame ȽavUnpkt.type
#define  JVS_UPKT_VIDEO		1			// Ƶ
#define  JVS_UPKT_AUDIO		2			// Ƶ

// 򿪽mp4ļϢ,ɵάִ˽ṹ
typedef struct _MP4_INFO
{
	char				szVideoMediaDataName[8];	// Ƶ "avc1"
	unsigned int		iFrameWidth;				// Ƶ
	unsigned int		iFrameHeight;				// Ƶ߶
	unsigned int		iNumVideoSamples;			// VideoSample
	double				dFrameRate;					// ֡
	MP4_AVCC			avcC;						// mp4 sps\pps
	
	char				szAudioMediaDataName[8];	// Ƶ "samr"
	unsigned int		iNumAudioSamples;			// AudioSample

	
}MP4_INFO, *PMP4_INFO;

// (ƵƵ),ɵάִ˽ṹ
typedef struct _AV_UNPKT
{
	unsigned int		iType;			// 	()
	unsigned int		iSampleId;		// Sample ID ()
	unsigned char *		pData;			// ָ ֻάһεõ
	unsigned int		iSize;			// ݴС
	unsigned __int64	iSampleTime;	// ʱ JP_UnpkgOneFrameֵ
	BOOL				bKeyFrame;		// ǷΪؼ֡()
}AV_UNPKT, *PAV_UNPKT;

typedef struct MP4_UPK *	MP4_UPK_HANDLE;	//  open


/**********************************************************************************
Function:		JP_OpenUnpkg
Description:	򿪽JP_CloseUnpkgɶʹ
Param:			
				char *			pszmp4file	// Ҫļ
				PMP4_INFO		pMp4Info	// AudioSampleAudioSample
Return:			ؽ, NULL,ʾʧ,ʾɹ  	  
**********************************************************************************/ 
JVS_API MP4_UPK_HANDLE  JP_OpenUnpkg	(char *pszmp4file, PMP4_INFO pMp4Info);


/**********************************************************************************
Function:		JP_CloseUnpkg
Description:	رսJP_OpenUnpkgɶʹ
Param:			
				MP4_PKG_HANDLE	h	// 
Return:			  
**********************************************************************************/
JVS_API void			JP_CloseUnpkg	(MP4_UPK_HANDLE h);


/**********************************************************************************
Function:		JP_UnpkgOneFrame
Description:	һ֡h264amr
Param:			MP4_UPK_HANDLE	h	// 
				PAV_UNPKT pAvUnpkt	// h264amr֡ݽṹ
Return:			 TURE,ʾɹFALSE,ʾʧ	  
**********************************************************************************/ 
JVS_API BOOL			JP_UnpkgOneFrame(MP4_UPK_HANDLE h, PAV_UNPKT pAvUnpkt);



typedef struct MP4_FILE *	MP4_FILE_HANDLE;		// ڷװmp4ļ

// ɵάִ˽ṹ
typedef struct _MP4_CHECK
{
	BOOL			bNormal;			// TRUE, ʾɷװ,FALSE, װڽ
	unsigned int	iDataStart;			// mp4ļݿʼλ
}MP4_CHECK, *PMP4_CHECK;

// mp4ļƵϢ,ɵάִ˽ṹ
typedef struct _JP_MP4_INFO
{
	BOOL				bHasVideo;					// ǷƵ
	BOOL				bHasAudio;					// ǷƵ
	unsigned int		iFrameWidth;				// Ƶ
	unsigned int		iFrameHeight;				// Ƶ߶
	double				dFrameRate;					// ֡
	MP4_AVCC			avcC;						// mp4 sps\pps
}JP_MP4_INFO, *PJP_MP4_INFO;

/**********************************************************************************
Function:		JP_CheckFile
Description:	mp4ǷΪڷװļ
				Ҫmp4ļ,ȵЩӿڣԾһAPI,
				 pMp4Check.bNormal = TRUE, ҪAPI,
				API
Param:			
				char *			pszmp4file		// Ҫmp4ļ
				PMP4_CHECK		pMp4Check		// mp4ļļ
Return:			TRUE,ɹ, FALSE, ʧ  	  
**********************************************************************************/ 
JVS_API BOOL				JP_CheckFile	(char *pszmp4file, PMP4_CHECK pMp4Check);


/**********************************************************************************
Function:		JP_OpenFile
Description:	mp4ļJP_CloseFileɶʹ
Param:			
				char *			pszmp4file	// Ҫļ
				unsigned int	iDataStart	// mp4ļݿʼλ
				char *			pszIdxFile	// ڸļ,ļɷװ
Return:			ؽ, NULL,ʾʧ,ʾɹ  	  
**********************************************************************************/
JVS_API MP4_FILE_HANDLE		JP_OpenFile		(char * pszmp4file, unsigned int iDataStart, char * pszIdxFile, PJP_MP4_INFO pMp4Info);


/**********************************************************************************
Function:		JP_ReadFile
Description:	һ֡h264amr
Param:			MP4_FILE_HANDLE	h			// 
				PAV_UNPKT		pAvUnpkt	// h264amr֡ݽṹ
Return:			0, ʾݿɶ,	  
**********************************************************************************/ 
JVS_API int					JP_ReadFile		(MP4_FILE_HANDLE mp4Handle, PAV_UNPKT pAvUnpkt);

/**********************************************************************************
Function:		JP_CloseFile
Description:	رսJP_OpenFileɶʹ
Param:			
				MP4_FILE_HANDLE	h			// 
Return:			  
**********************************************************************************/
JVS_API void				JP_CloseFile	(MP4_FILE_HANDLE mp4Handle);



#endif	// _JVS_PKG_H