// JVSDKDEMODlg.h : header file
//

#if !defined(AFX_JVSDKDEMODLG_H__81A26EE4_51E3_452C_A14D_DDA71EDCA8A0__INCLUDED_)
#define AFX_JVSDKDEMODLG_H__81A26EE4_51E3_452C_A14D_DDA71EDCA8A0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CJVSDKDEMODlg dialog

class CJVSDKDEMODlg : public CDialog
{
// Construction
public:
	CJVSDKDEMODlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CJVSDKDEMODlg)
	enum { IDD = IDD_JVSDKDEMO_DIALOG };
	CButton	m_chkCIF;
	CButton	m_chkSubStream;
	CButton	m_chkNTSC;
	CButton	m_chkWD1MODE;
	CComboBox	m_comboMode;
	CListBox	m_lstInfo;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CJVSDKDEMODlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	int			m_nCurSel;
	BOOL	m_bInit;
	LPVOID m_pSocket;		//ͨ

	// Generated message map functions
	//{{AFX_MSG(CJVSDKDEMODlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonOpen();
	afx_msg void OnDestroy();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnButtonClose();
	afx_msg void OnButtonOpenPreview();
	afx_msg void OnButtonStopPreview();
	afx_msg void OnButtonStartCompress();
	afx_msg void OnButtonStopCompress();
	afx_msg void OnButtonWrite();
	afx_msg void OnButtonStopWrite();
	afx_msg void OnButtonEnableOsd();
	afx_msg void OnButtonDisableOsd();
	afx_msg void OnButtonQp();
	afx_msg void OnButtonFullScreen();
	afx_msg void OnMove(int x, int y);
	afx_msg void OnButtonBitmap();
	afx_msg void OnButtonNetwork();
	afx_msg void OnCheckMovDetect();
	afx_msg void OnCheckAudioPreview();
	afx_msg void OnCheckAudioCompress();
	afx_msg void OnButtonSetMode();
	afx_msg void OnButtonCapFile();
	afx_msg void OnButtonRawData();
	//}}AFX_MSG
	afx_msg LRESULT OnSDKNotify(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_JVSDKDEMODLG_H__81A26EE4_51E3_452C_A14D_DDA71EDCA8A0__INCLUDED_)
